.TH spiffa 1 "Version 1.2, 7th May 2007" "David M. Balean"
.SH NAME
spiffa \- local backup and restore
.SH SYNOPSIS
\fBspiffa [options]\fP

.SH DESCRIPTION
The purpose of spiffa is to perform local backup and restore operations.  It is assumed that
this will be to and from a normal disk such as an external usb hard drive or a second
internal drive.
.br
.sp
.SS
\fBspiffa\fP
Invoking spiffa without options starts the program by loading the graphical user interface
which the user sees e.g.
.br
.sp
spiffa
.br
.sp
If options are used then spiffa carries out the relevant command without using the GUI, e.g.
.br
.sp
spiffa -r
.br
which restores from the latest backup.
.br
.SS
\fIGUI Main Window\fP
If the GUI is invoked the user sees the main window provided the user is a permitted user.
If not, a message appears suggesting that the user becomes "\fIroot\fP".
.br
The main window opens to the \fBActions\fP page.  Other available pages are \fBBackup Options\fP,
\fBOther Options\fP and \fBAbout\fP.  If the user is "\fIroot\fP" there are two more pages available,
\fBUsers\fP and \fBPathnames\fP.  Each page is liberally supplied with tooltips so that the user
can easily find what is required.  Below the notebook widget are fout button; \fBSAVE\fP,
\fBSAVE AS\fP, \fBLOAD\fP and  \fBQUIT\fP.  \fBSAVE\fP saves all the data from all the pages to the default
configuration file \fI/usr/local/etc/spiffa.conf\fP if this is default installation directory.  \fBSAVE AS\fP
allows the user to choose a different location and/or filename for the saved configuration file.
\fBLOAD\fP loads a configuration file chosen by the use for edit. \fBQUIT\fP terminates the spiffa frontend.
.br
\fBNote\fP that the file being edited IS NOT the configuration used for a backup, update or restore.
Unless a configuration file is specified in the \fBActions Page\fP the default file is used.
.br
.sp
.br
There are three main buttons, "\fIBACKUP\fP", "\fIINCREMENTAL BACKUP\fP" and "\fIRESTORE\fP".
By default they all make use of the configuration file "\fI/usr/local/etc/spiffa.conf\fP" if this was the
default installation directory.  Below the three main buttons there are two entry widgets,
"\fIConfiguration File\fP" and "\fIRestore Point\fP". If "\fIConfiguration File\fP" is empty then the default
configuration file is used for both types of backup and for the restore.  "\fIRestore Point\fP" is only
used by "\fIRESTORE\fP".  If it is not empty the restore is from that restore point assuming it exists!
The user can browse for each of these using the appropriate "\fIBROWSE\fP" button. Right clicking
on the "\fIRESTORE\fP"'s "\fIBROWSE\fP" button enables the user to restore a selection
from the default or chosen restore point. There will usually be a wait while the data loads. Underneath
there is a frame which contains reports of progress during a backup or restore.  During a backup or
restore the main window's icon flashes with an arrow.  This is a green left arrow for a normal backup,
yellow left arrow for an incremental backup and a right red arrow for a restore.  Also a rotating
"rainbow world" appears in the window. This is to the left of the "SPIFFA" logo for a backup and
to its right for a restore.
.br
.sp
\fBBackup Options Page\fP
.br
\fICompression\fP
.br
To the left there are some radio buttons  giving the user the choice of compression methods or none.
For ordinary use  "\fIGZIP\fP" appears to be a good choice but experimentation may be required.  Below
the radio buttons the user is given the choice of how many backups to keep. 
.br
\fIOld Backups\fP
.br
 When a backup has been completed without errors unwanted older backups may be deleted.
If the value is -1 then all backups are retained.  If 0 then only the current backup is retained:
all pre-existing backups are deleted (if there were nor errors).  Up to 100 old backups can be
retained using this interface.
.br
\fISAVE THIS PAGE\fP
.br
In the lower left corner is a large button to save the data of this page to the default
configuration file "\fI/usr/local/etc/spiffa.conf\fP" assuming this was the default installation directory.
.br
\fISources to backup\fP
.br
Towards the centre of this page is the list of sources that will be backed up.  Note that if
an entry here conflicts with the omissions list in \fBOther Options\fP the omission will
take precedence.
.br
\fINew Source\fP
.br
Towards the right of this page is a frame encompassing an entry widget for the pathname
of a new source, a button to add this source to the source list, a browse button to enable
the user to browse for a source, and a button to delete a source that has been highlighted
in the source list by clicking on it.  The source name entered must be the full pathname.
.br
\fIMount Point\fP
This is optional. If a mount point is specified there is a primitive check performed to ensure
that the mount point is actually mounted and that the destination is available on that mount
point. The purpose of this is to avoid writing a backup to a permanent directory which is
an unmounted mount point.
.br
\fIDestination Directory\fP
.br
Below the new source frame is another for the destination directory.  Once again the full
pathname should be entered and a browse button is present to make it easier.
.br
.sp
\fBOther Options Page\fP
.br
 \fIspiffa.log\fP
.br
At the top left corner is a frame containing radio buttons that select the options
for "\fI/usr/local/var/log/spiffa.log\fP".  If \fIspiffa\fP was installed somewhere other than the default,
then \fIspiffa.log\fP will be placed in the appropriate place. "\fINEW\fP" (overwrite) starts the log
afresh with each action. "\fIAPPEND\fP" adds the log of the current action to the end of the previous
log or starts the log if none is present.  "\fINONE\fP" results in no log file being generated.
.br
\fISAVE THIS PAGE\fP
.br
In the lower left corner is a large button to save the data of this page to the default
configuration file "\fI/usr/local/spiffa/spiffa.conf\fP".
.br
\fISources to omit\fP
.br
Towards the centre of this page is the list of sources that will omitted from the backup.  Note that if
an entry here conflicts with the sources for backup list in \fBBackup Options\fP the omission will
take precedence.  An omission may be a directory or a file.  If a directory the that includes all its
contents as well.
.br
\fINew omission\fP
.br
At the top right of the page is a frame for new omissions to be added to the omisssions list.
First there is an entry widget in which the use can insert the full pathname of a a directory or
file to omit from the backup.  Below this to the left is a button \fBADD New omission\fP which
the user clicks to add the omission to the list.  The \fBBrowse\fP button can be used to select
a directory or file which is placed in the entry widget instead of doing it manually.  There are three
directories that are always omitted; \fI/proc\fP, \fI/sys\fP and the \fBdestination directory\fP.  The destination
directory doesn't appear in the omissions list but \fI/proc\fP and \fI/sys\fP do and they can't be deleted.
.br
\fIDELETE Selected Omission\fP
.br
Below the frame is a the \fBDELETE Selected Omission\fP button.  If an entry in the omissions
list has been clicked to highlight it, clicking this button removes that entry from the list.
.br
\fISave existing files on restore\fP
.br
This checkbox is below the \fBDELETE Selected Omission\fP button.  Normally files are overwitten
on restore.  Selecting this checkbox causes copies to be retained.  Each old file is named
\fBfilenameXXX.spiffasave\fP where spiffasave is a decimal number.
.br
\fIRestore orphan files on restore\fP
.br
This checkbox is next.  It may be that during an incremental backup it is detected that a file is
no longer present in the source.  Any such file is marked as an orphan in spiffa's data.  If such files
are to be restored then this checkbox should be selected.
.br
.sp
\fBUsers Page\fP
.br
This page is only available if spiffa is invoked by "\fIroot\fP".  A normal user can use
the "\fIsu\fP" command from the command line in a terminal such as xterm, gnome-terminal
or konsole, then enter root's password and finally issue the "\fIspiffa\fP" command
on the command line.
.br
\fISAVE THIS PAGE\fP
.br
In the lower left corner is a large button to save the data of this page to the default
configuration file,  "\fI/usr/local/etc/spiffa.conf\fP" if the default installation was used.
.br
\fIUsers to allow\fP
.br
This list is towards the centre of the page and only the users in this list can operate spiffa.
The one exception is \fIroot\fP, the superuser, who can always use spiffa.
.br
\fINew User\fP
.br
As with other similar lists, there is a frame to the right for additions to the list.
At the top is an entry widget.  This takes the login name of a user.  Click the \fIADD New User\fP
button to place this entry in the users to allow list.
.br
\fIDELETE Selected User\fP
.br
To remove a user from the user list click on the user in the list to highlight that entry the click
the \fIDELETE Selected User\fP button.
.br
.sp
\fBPathnames Page\fP
.br
The pathnames page, like the users page, is only accessible by \fIroot\fP.
This page consists of a series of entry widgets for the commands used within spiffa's backup and
restore routines.  The commands are \fIsh\fP \fIcat\fP \fIgzip\fP \fIbzip2\fP and \fIln\fP.
Also included is the pathname for \fImtab\fP and the command to use with the \fIHtml Browser\fP.
The default values are probably right for most systems.  If not \fIroot\fP can use the appropriate
\fIBROWSE\fP button or enter the full pathname manually.  Use the \fISAVE THIS PAGE\fP button
to put the pathnames into \fI/usr/local/etc/spiffa.conf\fP, assuming the default installation was used. 
.br
.sp
\fBAbout Page\fP
.br
This page contains the copyright notice and a button \fIUSER MANUAL\fP to access
the html documentation.
.br
.sp
.SS
\fISpiffa with Options - NO GUI\fP
.br
The available options are:-
.br
.sp
\fB-b\fP backup.  This backs up the sources to the destination specified in
the configuration file.
.br
.sp
\fB--backup\fP same as -b
.br
.sp
\fB-i\fP incremental backup.  This updates the latest backup at the destination specified
in the configuration file.
.br
.sp
\fB-u\fP same as -i
.br
.sp
\fB--incremental\fP same as -i
.br
.sp
\fB--update\fP same as -i
.br
.sp
\fB-r\fP restore.  This restores the latest backup from the destination specified
in the configuration file.
.br
.sp
\fB--restore\fP same as -r
.br
.sp
\fB-f\fP\fIfilename\fP  use \fIfilename\fP as the configuration file
.br
.sp
\fB--file=\fP\fIfilename\fP same as -f
.br
.sp
\fB-p\fP   use restore point \fIpoint\fP for the restore
.br
.sp
\fB--point=\fP\fIrestorepoint\fP same as -p
.br
.sp
\fBNOTE\fP restorepoint and filename must be the full pathnames.
.br
.sp
\fBNOTE\fP restoring selected files is not available unless using the GUI.
.br
.SH "FILES"
This assumes that the installation was at "\fI/usr/local\fP".
.br
.sp
\fI/usr/local/bin/spiffa\fP 
.br
This is the frontend which can be started with or without the GUI.  Note that GTK is required.
.br
.sp
\fI/usr/local/bin/spiffaslave\fP
.br
This is the bit that does the actual work.  It has to run \fBsuid\fP otherwise
it can't access all files and directories.
.br
.sp
\fI/usr/local/etc/spiffa.conf\fP
.br
This is the default configuration file.  The following is an example:-
.br
# Configuration file for spiffa
.br
.sp
# Source files and directories for backup
.br
BACKUP_SOURCE = "/home/david/Test"
.br
.sp
# Source files and directories NOT for backup
.br
# If the contents of a directory are to be omitted
.br
# use a trailing slash with the directory name.
.br
# The directory name will then be included but not
.br
# its contents.  Without the trailing slash the directory
.br
# name and its contents are omitted.
.br
BACKUP_DENY = "/mnt"
.br
BACKUP_DENY = "/tmp"
.br
BACKUP_DENY = "/proc"
.br
.BACKUP_DENY = "/sys"
.br
.sp
# Only the following ordinary users are permitted to use spiffa
.br
# The superuser "root" doesn't need to be in this list
.br
USER = david
.br
.sp
# If the destination directory for the backup
# is mounted on a permanent mount point that is present
# even when it is not mounted, such as used with "/etc/fstab",
# specify it here so that spiffa won't write to it unless mounted.
MOUNT_POINT = "/media/MAXTOR"
.br
.sp
# The destination directory for the backup
.br
# This is also the source directory for a restore
.br
BACKUP_DESTINATION = "/media/disk"
.br
.sp
# The type of compression to use
.br
# This can be GZ BZ2 GZ_BZ2 or NONE
.br
COMPRESSION = GZ
.br
.sp
# The number of old backups to retain in addition to the current one.
.br
# The value should be from -1 to 100.
.br
# If this is -1 then all old backups are retained.
.br
KEEP_NUMBER = 3
.br
.sp
# Save copies of old files
.br
# If this is YES or TRUE or 1 then files that would be overwritten
.br
# during a restore are retained with XXX.spiffasave as a suffix
.br
# where XXX is a decimal number.
.br
SAVE_EXISTING_FILES = NO
.br
.sp
# Restore orphan files
.br
# When an incremental backup is performed,
.br
# files that have been deleted in the source since the initial backup
.br
# are marked as orphans.  If this is YES or TRUE or 1 then these files
.br
# will be restored in addition to the rest, otherwise they are ignored.
.br
RESTORE_ORPHANS = YES
.br
.sp
# Pathnames of commands etc. used by spiffa
.br
SH_PATHNAME = "/bin/sh"
.br
CAT_PATHNAME = "/bin/cat"
.br
GZIP_PATHNAME = "/bin/gzip"
.br
BZIP2_PATHNAME = "/usr/bin/bzip2"
.br
LN_PATHNAME = "/bin/ln"
.br
MTAB_PATHNAME = "/etc/mtab"
.br
BROWSER_PATHNAME = "htmlview %s"
.br
.sp
# Options for spiffa.log
.br
# This can be NEW, APPEND or NONE
.br
# The file "/usr/local/spiffa/spiffa.log" can be opened as a new file
.br
# or it can be appended to the existing file if present.  Alternatively
.br
# it may be preferred to have no file at all.
.br
LOG_TYPE = NEW
.br
.sp
\fI/usr/local/var/log/spiffa.log\fP
.br
If selected to be created this file gives a brief idea of what actions took place during
a backup, update backup or restore including errors and warnings. It also records the time
taken to perform the operation, the total number of names (dorectories and files) and if
it is an update the number of files skipped because they have not been modified.
It doesn't give a list of the directories and filenames backed up or restored.  For that
see \fIThe Restore Point\fP.
.br
.sp
\fI/usr/local/var/run/spiffaslave.pid\fP
This is created when "\fIspiffaslave\fP" starts up and destroyed when it exits. It prevents
two copies from running simultaneously which could be dodgy!
.br
.sp
\fIThe Restore Point\fP
.br
The restore point is a directory containing the information required for a restore.
It is placed in the destinaton directory specified in the configuration file.  The name
of the restore point indicates both when the backup took place and the hostname
of the computer that was backed up, for example:-
.br
.sp
spiffa_backup_mylaptop_2006_10_26_11_43_13
.br
.sp
In this case the hostname of the computer was mylaptop.  The time portion of the name
is in the form \fIYYYY_MM_DD_hh_mm_ss\fP where  \fIYYYY\fP is the year, \fIMM\fP is the month,
\fIDD\fP is the day of the month, \fIhh\fP is the hour, \fImm\fP is the minute and \fIss\fP the second.
.br
.sp
The restore point has the following contents:-
.br
\fIroot\fP
.br
This is the root of the backup tree.  It is designed so that all individual files and directories in the tree
can be inspected from a file browser such as nautilus.  If compression is used the files are compressed
individually. Special files and links are not compressed. It's easier to see what is there although it does take slightly more space on the disk.
.br
\fIdata\fP
.br
This is a list of the source pathnames with ownership, permission and times.  Also if there
are orphan files these are marked. The numeric data are hexadecimal.
.br
\fIerrors\fP
.br
This gives a brief description of what occurred and some details about any errors encountered.
The following is an example of a large backup:-
.br
.sp
spiffa version 1.3
BACKUP ERRORS Sat Sep  1 10:44:23 2007
User: david
Destination: /mnt/drive2_backup/spiffa_backup_octopus_2007_09_01_10_44_23
WARNING: Backup of "/sys" not permitted (omissions list)
WARNING: Backup of "/lost+found" not permitted (omissions list)
WARNING: Backup of "/proc" not permitted (omissions list)
WARNING: Backup of "/mnt" not permitted (omissions list)
WARNING: Backup of "/media" not permitted (omissions list)
FINISHED New Backup: Sat Sep  1 15:08:40 2007 : Elapsed Time 04:24:17
Errors 0 : Warnings 5 : Names Processed 403242
.br
.sp
\fIgz\fP, \fIbz2\fP or \fIgz_bz2\fP
.br
If no compression was specified that is all that appears otherwise there is an empty file
indicating the type of compression i.e \fIgz\fP, \fIbz2\fP or \fIgz_bz2\fP.
.br
.SH "NOTES"
The backend, \fIspiffaslave\fP, is started by \fIspiffa\fP and it communicates with spiffa using
the message system.    The configuration file should have restrictive permissions as this is read
by \fIspiffaslave\fP which runs \fIsuid\fP so that it can have full access to all directories and files.
.br
.SH "BUGS"
.br
The vermin get everywhere.  Seek and destroy!
.br
.SH "AUTHOR & COPYRIGHT"
spiffa version 1.2
.br
Copyright (C) 2007 David M. Balean <linprogs@balean.net>
.br
44 Wyong Road
.br
Killarney Vale
.br
NSW  2261
.br
AUSTRALIA
.br 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License or,
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.SH "SEE ALSO"
bash(1), cat(1), gzip(1), bzip2(1), ln(8), fstab(5), getmntent(3)
