/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <iostream>
#include <string>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <stdlib.h>
#include <glib.h>

#include "messages.h"

using namespace std;

Messages::Messages(int q, int mt)
{
  qid = q;
  mstype = mt;
}

Messages::~Messages(void)
{

}


bool Messages::send_message(int dtype, void *data)
{
  struct spiffa_msg msg;
  int len;

  // OK HERE...
  //  cout << "Messages - sending mtype= " << mtype << " : dtype= " << dtype << endl;

  msg.mtype = mstype;
  msg.dtype = dtype;

  if (data == NULL) data = (void *)"";
  if (dtype == SL_ALIVE)
    {
      len = sizeof(pid_t);
    }
  else len = strlen((char *)data) + 1; // include the zero byte

  if (len <= MBUFSIZE)
    {
      // If data is pid just that pid is copied
      // otherwise it is a NULL terminated string
      memcpy(msg.data, data, len);

      len += sizeof(int);

      if ( (msgsnd(qid, &msg, len, 0)) >= 0) return TRUE;
    }
  return FALSE;
}


