/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _MISC_H
#define _MISC_H

#include <iostream>
#include <list>
#include <string>

#include <stdlib.h>

#include <stdlib.h>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <gtk/gtk.h>

using namespace std;

namespace misc

{
  // "stat64" functions
  gboolean isfile(char *pathname);
  gboolean isdir(char *pathname);
  gboolean islink(char *pathname);
  gboolean ischardev(char *pathname);
  gboolean isblockdev(char *pathname);
  gboolean isfifo(char *pathname);
  gboolean issocket(char *pathname);
  gboolean isnode(char *pathname);
  gboolean isname(char *pathname);
  char *get_mode(char *pathname);
  unsigned int hex2ui(char *str);
  gboolean get_fsize(char *fname, off64_t *size);
  
  void find_hostname(string *hostname, string *m);
  
  GtkWidget *create_spinner(int s_start, int s_min, int s_max);
  GtkStyle *create_style(GdkColor fg, GdkColor text, GdkColor bg);

  void remove_leading_and_terminal_space(string &str);
  void time2string(time_t t, string &t_str);

  int suficmp(char *string, char *suffix);
  int sufcmp(char *string, char *suffix);

  int STREQ(char *x, char *y);
  int STRIEQ(char *x, char *y);
  int STREQN(char *x, char *y, int n);
  int STRIEQN(char *x, char *y, int n);
  int SUFEQ(char *x, char *y);
  int SUFIEQ(char *x, char *y);

};


#endif // _MISC_H
