/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <sys/stat.h>

#include "tfile.h" 

string TFile::a_val;

TFile::TFile(void)
{
//cout << "TFile:\n";
}
        
TFile::~TFile(void)
{
//cout << "~TFile:\n";
}

int TFile::power(int n, int base)
{
int p;

for (p=1; n>0; --n)
  {
  p *= base;
  }

return(p);
}

string &TFile::itoa(int n)
{
return(itoa(n, 0));
}  
  
   
string &TFile::itoa(int n, int pad)
{
char buffer[512];
char *c = &buffer[511];
int sign = (n<0) ? 1 : 0;
unsigned int p = abs(pad);

 n = abs(n);

*c-- =  '\0';

do
    {
    *c-- = (n % 10) + '0'; 
    }
    while  ( (n /= 10) > 0 );


if (sign) *c = '-';
else c++;

a_val = c;

while (a_val.length() < p)
    {
    a_val = '0' + a_val;
    }
    
return(a_val);    
}

// Return a filename only or NULL if failure
string *TFile::tname(string *pathname, int n, string *suffix)
{
static string fname;
struct stat statbuf;

int max = power(10, n);
  
// i represents the suffix put into a_val
for (int i=0; i<max; i++)
  {
  itoa(i, n);
  fname = *pathname + a_val + (*suffix);

  if (stat(fname.c_str(), &statbuf)) // if it doesn't exist
  return &fname;
  }
return NULL;
}

string *TFile::tname(string *pathname, int n)
{
string suffix = "";
return(tname(pathname, n, &suffix));
}

// Return the filename (string, not char *) of filestream ofp or NULL if failure
string *TFile::tfile(string *pathname, fstream *ofp, int n, string *suffix)
{
static string fname;
struct stat statbuf;

int max = power(10, n);
  
// i represents the suffix put into a_val
for (int i=0; i<max; i++)
  {
  itoa(i, n);
  fname = *pathname + a_val + (*suffix);

  cout << "TFile::tfile: checking fname: " << fname << endl;

  if (stat(fname.c_str(), &statbuf)) // if it doesn't exist
    {
    ofp->open(fname.c_str(), ios::out | ios::binary | ios::trunc );
    if ( ofp->is_open() ) return(&fname);
    }
  }
return(NULL);
}



string *TFile::tfile(string *pathname, fstream *ofp, int n)
{
string suffix = "";
return(  tfile(pathname, ofp, n, &suffix) );
}



string *TFile::tfile(string *pathname, fstream *ofp)
{
return( tfile(pathname, ofp, 3) );
}

int TFile::do_copy(fstream *ofp, fstream *ifp)
{
if (ifp && ofp && ifp->is_open() && ofp->is_open() )
  {
  char c;
      
  while (ofp && ifp->get(c))
        ofp->put(c);
  return(1);  
  }
return(0);
}


int TFile::filecopy(string *dname, string *sname, int overwrite)
{
fstream ofile;
int rc;

fstream ifile( sname->c_str(), ios::in  | ios::binary );
if (overwrite)
  {
  ofile.open(dname->c_str(), ios::out | ios::binary | ios::trunc );
  }
else ofile.open( dname->c_str(), ios::out | ios::binary );
rc = (do_copy(&ofile, &ifile));
ofile.close();
ifile.close();
return(rc);
}

int TFile::overwritefile(string *dname, string *sname)
{
return(filecopy(dname, sname, 1));
}

int TFile::filecopy(string *dname, string *sname)
{
return(filecopy(dname, sname, 0));
}

string *TFile::copy(string *pathname, int n)
{
static string fname;
struct stat statbuf;

int max = power(n, 10);

// i represents the suffix put into a_val
for (int i=0; i<max; i++)
  {
  itoa(i, n);
  fname = *pathname + a_val;

  if (stat(fname.c_str(), &statbuf)) // if it doesn't exist
    {
    if (filecopy(&fname, pathname, 0))
      {
      return(&fname);
      }
    // otherwise try the next possible
    }
  }
return(NULL); 
}

string *TFile::copy(string *pathname)
{
return(copy(pathname, 3));
}
