/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _TFILE_H
#define _TFILE_H

#include <iostream>
#include <fstream>


using namespace std;

class TFile
{
public:
  TFile(void);
  ~TFile(void);

  static string &itoa(int n,  int pad);
  static string &itoa(int n);
  static int power(int n, int base);

  string *tname(string *pathname, int n, string *suffix);
  string *tname(string *pathname, int n);

  string *tfile(string *pathname, fstream *ofp, int n, string *suffix);
  string *tfile(string *pathname, fstream *ofp, int n);
  string *tfile(string *pathname, fstream *ofp);

  int filecopy(string *dname, string *sname);
  int overwritefile(string *dname, string *sname);
                
  string *copy(string *pathname, int n);
  string *copy(string *pathname);
  int do_copy(fstream *ofp, fstream *ifp);
        
private:        
  int filecopy(string *dname, string *sname, int overwite);        

  static string a_val;
        
protected:
 
};
 
#endif // _TFILE_H
