/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _BUSYWORLD_H
#define _BUSYWORLD_H

#include "frontend.h"

class BusyWorld
  {
  public:

    BusyWorld(class Frontend *f);
    ~BusyWorld(void);

    gboolean busy_world(void);

  private:
    void clear2white(GdkPixbuf **pb);
    void scale_image(GdkPixbuf **pb_dest, GdkPixbuf **pb_src);

    static const guint8 rw0_pixbuf[];
    static const guint8 rw1_pixbuf[];
    static const guint8 rw2_pixbuf[];
    static const guint8 rw3_pixbuf[];
    static const guint8 rw4_pixbuf[];
    static const guint8 rw5_pixbuf[];
    static const guint8 rw6_pixbuf[];
    static GdkPixbuf *rainbow_world_pixbuf[7]; // Rainbow World animation

    GdkPixbuf *pixbuf_w;                       // current rainbow_world_image

    static const guint8 blank_pixbuf[];
    static const guint8 bu_pixbuf[];
    static const guint8 up_pixbuf[];
    static const guint8 rs_pixbuf[];

    GdkPixbuf *blank_icon;
    GdkPixbuf *bu_icon;
    GdkPixbuf *up_icon;
    GdkPixbuf *rs_icon;

    Frontend *frontend;

  protected:

  };

#endif // _BUSYWORLD_H
