/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _COMPLAIN_H
#define _COMPLAIN_H

#include <gtk/gtk.h>


class Complain
{
 public:
  Complain(void);
  ~Complain(void);


  void complain (int n, char *title, char *msg, 
                void (*YesFunc)(GtkWidget *widget, Complain *c), 
                void (*NoFunc)(GtkWidget *widget, Complain *c),
                gpointer d );

  static void end_complain(GtkWidget *widget, Complain *c);
  static void clear_complain(GtkWidget *widget, Complain *c);

  static void left_button(GtkWidget *widget, Complain *c);

  static const int CN_ABORT        = 0;
  static const int CN_CONTINUE     = 1;
  static const int CN_OK           = 2;
  static const int CN_CANCEL       = 3;
  static const int CN_OK_CANCEL    = 4;
  static const int CN_OK_ABORT     = 5;
  static const int CN_RETRY_ABORT  = 6;
  static const int CN_RETRY_CANCEL = 7;
  static const int CN_YES_NO       = 8;

  gpointer data;

 private:
  GtkWidget *dialog_window;

  GdkPixbuf *pixbuf;


 protected:

};

#endif // _COMPLAIN_H
