/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _SPIFFA_H
#define _SPIFFA_H

#include <iostream>
#include <list>

#include "../common/messages.h"
#include "frontend.h"
#include "complain.h"

using namespace std;

class Spiffa
{
friend class SpiffaMessages;   // Allow SpiffaMessages to access everything
friend class Frontend;              // Allow Frontend to access everything

public:
 Spiffa(int argc, char *argv[]);
 ~Spiffa(void);

private:
 static void complain_abort(GtkWidget *widget, Complain *c);

 void start_slave(pid_t pid);
 void get_conf(class SpiffaMessages &m);

 pid_t slave_pid;
 bool no_permission_flag;
 string no_permission_txt;

 bool quit_flag;
 bool conf_done;

 int qid;                      // id of message queue

 list<string> sources;
 list<string> omissions;
 list<string> users;

 string mount_point;
 string backup_destination;
 string compression;
 int keep_number;
 bool save_existing_files;
 bool restore_orphans;

 string sh_pname;
 string cat_pname;
 string gzip_pname;
 string bzip2_pname;
 string ln_pname;
 string mtab_pname;
 static string browser_pname;

 string log_type;

 bool slave_working;

protected:

};

#endif // _SPIFFA_H
